package org.apache.jmeter;

import java.util.Vector;
import org.apache.jmeter.timers.Timer;
import org.apache.jmeter.samplers.SampleListener;
import org.apache.jmeter.threads.JMeterThread;
import org.apache.jmeter.controllers.SamplerController;

public class JMeterEngine {
    JMeterThread[][] threads;
    Vector sample_listeners;
    Timer timer;
    SamplerController controller;
    
    public JMeterEngine() {
	sample_listeners = new Vector();
    }
    
    public void addSampleListener(SampleListener listener) {
	sample_listeners.addElement(listener);
    }

    public void removeSampleListener(SampleListener listener) {
	sample_listeners.removeElement(listener);
    }

    public void setTimer(Timer t) {
	timer=t;
    }

    public void setSamplerController(SamplerController sc) {
	controller=sc;
    }

    public void start(String[] groups, int[] thread_counts) {
	if( groups == null ) {
	    // I _detest_ null pointer exceptions...
	    throw new IllegalStateException
		("No thread groups to work with");
	}
	threads = new JMeterThread[groups.length][];
	controller.start();
	for(int i=0;i<groups.length;i++) {
	    threads[i]=controller.getSampleThreads
		(groups[i], thread_counts[i]);
	    if (threads[i]!=null)
		for(int j=0;j<threads[i].length;j++) {
		    for(int k=0;k<sample_listeners.size();k++)
			threads[i][j].addSampleListener
			    ((SampleListener)sample_listeners.elementAt(k));
		    threads[i][j].setTimer(timer);
		    new Thread(threads[i][j]).start();
		}
	}
	//lagger = new LagDetector();
	//lagger.start();
    }
    
    public void stop() {
	for (int i=0;i<threads.length;i++)
	    if (threads[i]!=null)
		for(int j=0;j<threads[i].length;j++)
		    threads[i][j].stopSampling();
	controller.stop();
	// lagger.stopRunning();
	// System.out.println("Average lag = "+lagger.getAveLag());
	// System.out.println("Lag ratio = "+lagger.getLagRatio());
    }
}
