
/**
 * Title:        JMeter<p>
 * Description:  <p>
 * Copyright:    Copyright (c) Michael Stover<p>
 * Company:      Apache JMeter<p>
 * @author Michael Stover
 * @version 1.0
 */
package org.apache.jmeter.util;

import java.io.*;
import org.xml.sax.*;

public interface Saveable
{
  /**
   *  Gets the SAX document handler to read the xml that stores information
   *  necessary for the reconstruction of this type of object.
   */
  public HandlerBase getHandlerBase();

  /**
   * Causes the object to be initialized with the given SAX document handler object.
   * Throws an exception if the given saxHandler doesn't hold information relevant
   * to this type of object.
   */
  public void load(HandlerBase handler) throws BadHandlerException;

  /**
   * Tells the object to save itself to the given output stream.
   */
  public void save(OutputStream out) throws IOException;

  /**
   * A method for setting or adding other saveable objects to this object, for configuration
   * purposes.
   */
   public void addSaveableObject(Saveable o);
}
